=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'cgi'

module PulpOstreeClient
  class DistributionsOstreeApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create an ostree distribution
    # Trigger an asynchronous create task
    # @param ostree_ostree_distribution [OstreeOstreeDistribution] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def create(ostree_ostree_distribution, opts = {})
      data, _status_code, _headers = create_with_http_info(ostree_ostree_distribution, opts)
      data
    end

    # Create an ostree distribution
    # Trigger an asynchronous create task
    # @param ostree_ostree_distribution [OstreeOstreeDistribution] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def create_with_http_info(ostree_ostree_distribution, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: DistributionsOstreeApi.create ...'
      end
      # verify the required parameter 'ostree_ostree_distribution' is set
      if @api_client.config.client_side_validation && ostree_ostree_distribution.nil?
        fail ArgumentError, "Missing the required parameter 'ostree_ostree_distribution' when calling DistributionsOstreeApi.create"
      end
      # resource path
      local_var_path = '/pulp/api/v3/distributions/ostree/ostree/'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(ostree_ostree_distribution) 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: DistributionsOstreeApi#create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Delete an ostree distribution
    # Trigger an asynchronous delete task
    # @param ostree_ostree_distribution_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def delete(ostree_ostree_distribution_href, opts = {})
      data, _status_code, _headers = delete_with_http_info(ostree_ostree_distribution_href, opts)
      data
    end

    # Delete an ostree distribution
    # Trigger an asynchronous delete task
    # @param ostree_ostree_distribution_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def delete_with_http_info(ostree_ostree_distribution_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: DistributionsOstreeApi.delete ...'
      end
      # verify the required parameter 'ostree_ostree_distribution_href' is set
      if @api_client.config.client_side_validation && ostree_ostree_distribution_href.nil?
        fail ArgumentError, "Missing the required parameter 'ostree_ostree_distribution_href' when calling DistributionsOstreeApi.delete"
      end
      # resource path
      local_var_path = '{ostree_ostree_distribution_href}'.sub('{' + 'ostree_ostree_distribution_href' + '}', CGI.escape(ostree_ostree_distribution_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: DistributionsOstreeApi#delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List ostree distributions
    # A ViewSet class for OSTree distributions.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :base_path 
    # @option opts [String] :base_path__contains Filter results where base_path contains value
    # @option opts [String] :base_path__icontains Filter results where base_path contains value
    # @option opts [Array<String>] :base_path__in Filter results where base_path is in a comma-separated list of values
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :name 
    # @option opts [String] :name__contains Filter results where name contains value
    # @option opts [String] :name__icontains Filter results where name contains value
    # @option opts [Array<String>] :name__in Filter results where name is in a comma-separated list of values
    # @option opts [String] :name__startswith Filter results where name starts with value
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :pulp_label_select Filter labels by search string
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [PaginatedostreeOstreeDistributionResponseList]
    def list(opts = {})
      data, _status_code, _headers = list_with_http_info(opts)
      data
    end

    # List ostree distributions
    # A ViewSet class for OSTree distributions.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :base_path 
    # @option opts [String] :base_path__contains Filter results where base_path contains value
    # @option opts [String] :base_path__icontains Filter results where base_path contains value
    # @option opts [Array<String>] :base_path__in Filter results where base_path is in a comma-separated list of values
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :name 
    # @option opts [String] :name__contains Filter results where name contains value
    # @option opts [String] :name__icontains Filter results where name contains value
    # @option opts [Array<String>] :name__in Filter results where name is in a comma-separated list of values
    # @option opts [String] :name__startswith Filter results where name starts with value
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :pulp_label_select Filter labels by search string
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(PaginatedostreeOstreeDistributionResponseList, Integer, Hash)>] PaginatedostreeOstreeDistributionResponseList data, response status code and response headers
    def list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: DistributionsOstreeApi.list ...'
      end
      # resource path
      local_var_path = '/pulp/api/v3/distributions/ostree/ostree/'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'base_path'] = opts[:'base_path'] if !opts[:'base_path'].nil?
      query_params[:'base_path__contains'] = opts[:'base_path__contains'] if !opts[:'base_path__contains'].nil?
      query_params[:'base_path__icontains'] = opts[:'base_path__icontains'] if !opts[:'base_path__icontains'].nil?
      query_params[:'base_path__in'] = @api_client.build_collection_param(opts[:'base_path__in'], :csv) if !opts[:'base_path__in'].nil?
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'name'] = opts[:'name'] if !opts[:'name'].nil?
      query_params[:'name__contains'] = opts[:'name__contains'] if !opts[:'name__contains'].nil?
      query_params[:'name__icontains'] = opts[:'name__icontains'] if !opts[:'name__icontains'].nil?
      query_params[:'name__in'] = @api_client.build_collection_param(opts[:'name__in'], :csv) if !opts[:'name__in'].nil?
      query_params[:'name__startswith'] = opts[:'name__startswith'] if !opts[:'name__startswith'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'ordering'] = opts[:'ordering'] if !opts[:'ordering'].nil?
      query_params[:'pulp_label_select'] = opts[:'pulp_label_select'] if !opts[:'pulp_label_select'].nil?
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'PaginatedostreeOstreeDistributionResponseList' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: DistributionsOstreeApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update an ostree distribution
    # Trigger an asynchronous partial update task
    # @param ostree_ostree_distribution_href [String] 
    # @param patchedostree_ostree_distribution [PatchedostreeOstreeDistribution] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def partial_update(ostree_ostree_distribution_href, patchedostree_ostree_distribution, opts = {})
      data, _status_code, _headers = partial_update_with_http_info(ostree_ostree_distribution_href, patchedostree_ostree_distribution, opts)
      data
    end

    # Update an ostree distribution
    # Trigger an asynchronous partial update task
    # @param ostree_ostree_distribution_href [String] 
    # @param patchedostree_ostree_distribution [PatchedostreeOstreeDistribution] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def partial_update_with_http_info(ostree_ostree_distribution_href, patchedostree_ostree_distribution, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: DistributionsOstreeApi.partial_update ...'
      end
      # verify the required parameter 'ostree_ostree_distribution_href' is set
      if @api_client.config.client_side_validation && ostree_ostree_distribution_href.nil?
        fail ArgumentError, "Missing the required parameter 'ostree_ostree_distribution_href' when calling DistributionsOstreeApi.partial_update"
      end
      # verify the required parameter 'patchedostree_ostree_distribution' is set
      if @api_client.config.client_side_validation && patchedostree_ostree_distribution.nil?
        fail ArgumentError, "Missing the required parameter 'patchedostree_ostree_distribution' when calling DistributionsOstreeApi.partial_update"
      end
      # resource path
      local_var_path = '{ostree_ostree_distribution_href}'.sub('{' + 'ostree_ostree_distribution_href' + '}', CGI.escape(ostree_ostree_distribution_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(patchedostree_ostree_distribution) 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: DistributionsOstreeApi#partial_update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Inspect an ostree distribution
    # A ViewSet class for OSTree distributions.
    # @param ostree_ostree_distribution_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [OstreeOstreeDistributionResponse]
    def read(ostree_ostree_distribution_href, opts = {})
      data, _status_code, _headers = read_with_http_info(ostree_ostree_distribution_href, opts)
      data
    end

    # Inspect an ostree distribution
    # A ViewSet class for OSTree distributions.
    # @param ostree_ostree_distribution_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(OstreeOstreeDistributionResponse, Integer, Hash)>] OstreeOstreeDistributionResponse data, response status code and response headers
    def read_with_http_info(ostree_ostree_distribution_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: DistributionsOstreeApi.read ...'
      end
      # verify the required parameter 'ostree_ostree_distribution_href' is set
      if @api_client.config.client_side_validation && ostree_ostree_distribution_href.nil?
        fail ArgumentError, "Missing the required parameter 'ostree_ostree_distribution_href' when calling DistributionsOstreeApi.read"
      end
      # resource path
      local_var_path = '{ostree_ostree_distribution_href}'.sub('{' + 'ostree_ostree_distribution_href' + '}', CGI.escape(ostree_ostree_distribution_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'OstreeOstreeDistributionResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: DistributionsOstreeApi#read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update an ostree distribution
    # Trigger an asynchronous update task
    # @param ostree_ostree_distribution_href [String] 
    # @param ostree_ostree_distribution [OstreeOstreeDistribution] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def update(ostree_ostree_distribution_href, ostree_ostree_distribution, opts = {})
      data, _status_code, _headers = update_with_http_info(ostree_ostree_distribution_href, ostree_ostree_distribution, opts)
      data
    end

    # Update an ostree distribution
    # Trigger an asynchronous update task
    # @param ostree_ostree_distribution_href [String] 
    # @param ostree_ostree_distribution [OstreeOstreeDistribution] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def update_with_http_info(ostree_ostree_distribution_href, ostree_ostree_distribution, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: DistributionsOstreeApi.update ...'
      end
      # verify the required parameter 'ostree_ostree_distribution_href' is set
      if @api_client.config.client_side_validation && ostree_ostree_distribution_href.nil?
        fail ArgumentError, "Missing the required parameter 'ostree_ostree_distribution_href' when calling DistributionsOstreeApi.update"
      end
      # verify the required parameter 'ostree_ostree_distribution' is set
      if @api_client.config.client_side_validation && ostree_ostree_distribution.nil?
        fail ArgumentError, "Missing the required parameter 'ostree_ostree_distribution' when calling DistributionsOstreeApi.update"
      end
      # resource path
      local_var_path = '{ostree_ostree_distribution_href}'.sub('{' + 'ostree_ostree_distribution_href' + '}', CGI.escape(ostree_ostree_distribution_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(ostree_ostree_distribution) 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PUT, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: DistributionsOstreeApi#update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
