=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'cgi'

module PulpOstreeClient
  class RepositoriesOstreeApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create an ostree repository
    # A ViewSet class for OSTree repositories.
    # @param ostree_ostree_repository [OstreeOstreeRepository] 
    # @param [Hash] opts the optional parameters
    # @return [OstreeOstreeRepositoryResponse]
    def create(ostree_ostree_repository, opts = {})
      data, _status_code, _headers = create_with_http_info(ostree_ostree_repository, opts)
      data
    end

    # Create an ostree repository
    # A ViewSet class for OSTree repositories.
    # @param ostree_ostree_repository [OstreeOstreeRepository] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(OstreeOstreeRepositoryResponse, Integer, Hash)>] OstreeOstreeRepositoryResponse data, response status code and response headers
    def create_with_http_info(ostree_ostree_repository, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesOstreeApi.create ...'
      end
      # verify the required parameter 'ostree_ostree_repository' is set
      if @api_client.config.client_side_validation && ostree_ostree_repository.nil?
        fail ArgumentError, "Missing the required parameter 'ostree_ostree_repository' when calling RepositoriesOstreeApi.create"
      end
      # resource path
      local_var_path = '/pulp/api/v3/repositories/ostree/ostree/'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(ostree_ostree_repository) 

      # return_type
      return_type = opts[:return_type] || 'OstreeOstreeRepositoryResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesOstreeApi#create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Delete an ostree repository
    # Trigger an asynchronous delete task
    # @param ostree_ostree_repository_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def delete(ostree_ostree_repository_href, opts = {})
      data, _status_code, _headers = delete_with_http_info(ostree_ostree_repository_href, opts)
      data
    end

    # Delete an ostree repository
    # Trigger an asynchronous delete task
    # @param ostree_ostree_repository_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def delete_with_http_info(ostree_ostree_repository_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesOstreeApi.delete ...'
      end
      # verify the required parameter 'ostree_ostree_repository_href' is set
      if @api_client.config.client_side_validation && ostree_ostree_repository_href.nil?
        fail ArgumentError, "Missing the required parameter 'ostree_ostree_repository_href' when calling RepositoriesOstreeApi.delete"
      end
      # resource path
      local_var_path = '{ostree_ostree_repository_href}'.sub('{' + 'ostree_ostree_repository_href' + '}', CGI.escape(ostree_ostree_repository_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesOstreeApi#delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Import commits to a repository
    # Trigger an asynchronous task to create a new OSTree repository version.
    # @param ostree_ostree_repository_href [String] 
    # @param ostree_repo_import [OstreeRepoImport] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def import_commits(ostree_ostree_repository_href, ostree_repo_import, opts = {})
      data, _status_code, _headers = import_commits_with_http_info(ostree_ostree_repository_href, ostree_repo_import, opts)
      data
    end

    # Import commits to a repository
    # Trigger an asynchronous task to create a new OSTree repository version.
    # @param ostree_ostree_repository_href [String] 
    # @param ostree_repo_import [OstreeRepoImport] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def import_commits_with_http_info(ostree_ostree_repository_href, ostree_repo_import, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesOstreeApi.import_commits ...'
      end
      # verify the required parameter 'ostree_ostree_repository_href' is set
      if @api_client.config.client_side_validation && ostree_ostree_repository_href.nil?
        fail ArgumentError, "Missing the required parameter 'ostree_ostree_repository_href' when calling RepositoriesOstreeApi.import_commits"
      end
      # verify the required parameter 'ostree_repo_import' is set
      if @api_client.config.client_side_validation && ostree_repo_import.nil?
        fail ArgumentError, "Missing the required parameter 'ostree_repo_import' when calling RepositoriesOstreeApi.import_commits"
      end
      # resource path
      local_var_path = '{ostree_ostree_repository_href}import_commits/'.sub('{' + 'ostree_ostree_repository_href' + '}', CGI.escape(ostree_ostree_repository_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(ostree_repo_import) 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesOstreeApi#import_commits\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List ostree repositorys
    # A ViewSet class for OSTree repositories.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :name 
    # @option opts [String] :name__contains Filter results where name contains value
    # @option opts [String] :name__icontains Filter results where name contains value
    # @option opts [Array<String>] :name__in Filter results where name is in a comma-separated list of values
    # @option opts [String] :name__startswith Filter results where name starts with value
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :pulp_label_select Filter labels by search string
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [PaginatedostreeOstreeRepositoryResponseList]
    def list(opts = {})
      data, _status_code, _headers = list_with_http_info(opts)
      data
    end

    # List ostree repositorys
    # A ViewSet class for OSTree repositories.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :name 
    # @option opts [String] :name__contains Filter results where name contains value
    # @option opts [String] :name__icontains Filter results where name contains value
    # @option opts [Array<String>] :name__in Filter results where name is in a comma-separated list of values
    # @option opts [String] :name__startswith Filter results where name starts with value
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :pulp_label_select Filter labels by search string
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(PaginatedostreeOstreeRepositoryResponseList, Integer, Hash)>] PaginatedostreeOstreeRepositoryResponseList data, response status code and response headers
    def list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesOstreeApi.list ...'
      end
      # resource path
      local_var_path = '/pulp/api/v3/repositories/ostree/ostree/'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'name'] = opts[:'name'] if !opts[:'name'].nil?
      query_params[:'name__contains'] = opts[:'name__contains'] if !opts[:'name__contains'].nil?
      query_params[:'name__icontains'] = opts[:'name__icontains'] if !opts[:'name__icontains'].nil?
      query_params[:'name__in'] = @api_client.build_collection_param(opts[:'name__in'], :csv) if !opts[:'name__in'].nil?
      query_params[:'name__startswith'] = opts[:'name__startswith'] if !opts[:'name__startswith'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'ordering'] = opts[:'ordering'] if !opts[:'ordering'].nil?
      query_params[:'pulp_label_select'] = opts[:'pulp_label_select'] if !opts[:'pulp_label_select'].nil?
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'PaginatedostreeOstreeRepositoryResponseList' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesOstreeApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Modify Repository Content
    # Trigger an asynchronous task to create a new repository version.
    # @param ostree_ostree_repository_href [String] 
    # @param repository_add_remove_content [RepositoryAddRemoveContent] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def modify(ostree_ostree_repository_href, repository_add_remove_content, opts = {})
      data, _status_code, _headers = modify_with_http_info(ostree_ostree_repository_href, repository_add_remove_content, opts)
      data
    end

    # Modify Repository Content
    # Trigger an asynchronous task to create a new repository version.
    # @param ostree_ostree_repository_href [String] 
    # @param repository_add_remove_content [RepositoryAddRemoveContent] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def modify_with_http_info(ostree_ostree_repository_href, repository_add_remove_content, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesOstreeApi.modify ...'
      end
      # verify the required parameter 'ostree_ostree_repository_href' is set
      if @api_client.config.client_side_validation && ostree_ostree_repository_href.nil?
        fail ArgumentError, "Missing the required parameter 'ostree_ostree_repository_href' when calling RepositoriesOstreeApi.modify"
      end
      # verify the required parameter 'repository_add_remove_content' is set
      if @api_client.config.client_side_validation && repository_add_remove_content.nil?
        fail ArgumentError, "Missing the required parameter 'repository_add_remove_content' when calling RepositoriesOstreeApi.modify"
      end
      # resource path
      local_var_path = '{ostree_ostree_repository_href}modify/'.sub('{' + 'ostree_ostree_repository_href' + '}', CGI.escape(ostree_ostree_repository_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(repository_add_remove_content) 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesOstreeApi#modify\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update an ostree repository
    # Trigger an asynchronous partial update task
    # @param ostree_ostree_repository_href [String] 
    # @param patchedostree_ostree_repository [PatchedostreeOstreeRepository] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def partial_update(ostree_ostree_repository_href, patchedostree_ostree_repository, opts = {})
      data, _status_code, _headers = partial_update_with_http_info(ostree_ostree_repository_href, patchedostree_ostree_repository, opts)
      data
    end

    # Update an ostree repository
    # Trigger an asynchronous partial update task
    # @param ostree_ostree_repository_href [String] 
    # @param patchedostree_ostree_repository [PatchedostreeOstreeRepository] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def partial_update_with_http_info(ostree_ostree_repository_href, patchedostree_ostree_repository, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesOstreeApi.partial_update ...'
      end
      # verify the required parameter 'ostree_ostree_repository_href' is set
      if @api_client.config.client_side_validation && ostree_ostree_repository_href.nil?
        fail ArgumentError, "Missing the required parameter 'ostree_ostree_repository_href' when calling RepositoriesOstreeApi.partial_update"
      end
      # verify the required parameter 'patchedostree_ostree_repository' is set
      if @api_client.config.client_side_validation && patchedostree_ostree_repository.nil?
        fail ArgumentError, "Missing the required parameter 'patchedostree_ostree_repository' when calling RepositoriesOstreeApi.partial_update"
      end
      # resource path
      local_var_path = '{ostree_ostree_repository_href}'.sub('{' + 'ostree_ostree_repository_href' + '}', CGI.escape(ostree_ostree_repository_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(patchedostree_ostree_repository) 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesOstreeApi#partial_update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Inspect an ostree repository
    # A ViewSet class for OSTree repositories.
    # @param ostree_ostree_repository_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [OstreeOstreeRepositoryResponse]
    def read(ostree_ostree_repository_href, opts = {})
      data, _status_code, _headers = read_with_http_info(ostree_ostree_repository_href, opts)
      data
    end

    # Inspect an ostree repository
    # A ViewSet class for OSTree repositories.
    # @param ostree_ostree_repository_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(OstreeOstreeRepositoryResponse, Integer, Hash)>] OstreeOstreeRepositoryResponse data, response status code and response headers
    def read_with_http_info(ostree_ostree_repository_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesOstreeApi.read ...'
      end
      # verify the required parameter 'ostree_ostree_repository_href' is set
      if @api_client.config.client_side_validation && ostree_ostree_repository_href.nil?
        fail ArgumentError, "Missing the required parameter 'ostree_ostree_repository_href' when calling RepositoriesOstreeApi.read"
      end
      # resource path
      local_var_path = '{ostree_ostree_repository_href}'.sub('{' + 'ostree_ostree_repository_href' + '}', CGI.escape(ostree_ostree_repository_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'OstreeOstreeRepositoryResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesOstreeApi#read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Sync from remote
    # Trigger an asynchronous task to sync content.
    # @param ostree_ostree_repository_href [String] 
    # @param repository_sync_url [RepositorySyncURL] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def sync(ostree_ostree_repository_href, repository_sync_url, opts = {})
      data, _status_code, _headers = sync_with_http_info(ostree_ostree_repository_href, repository_sync_url, opts)
      data
    end

    # Sync from remote
    # Trigger an asynchronous task to sync content.
    # @param ostree_ostree_repository_href [String] 
    # @param repository_sync_url [RepositorySyncURL] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def sync_with_http_info(ostree_ostree_repository_href, repository_sync_url, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesOstreeApi.sync ...'
      end
      # verify the required parameter 'ostree_ostree_repository_href' is set
      if @api_client.config.client_side_validation && ostree_ostree_repository_href.nil?
        fail ArgumentError, "Missing the required parameter 'ostree_ostree_repository_href' when calling RepositoriesOstreeApi.sync"
      end
      # verify the required parameter 'repository_sync_url' is set
      if @api_client.config.client_side_validation && repository_sync_url.nil?
        fail ArgumentError, "Missing the required parameter 'repository_sync_url' when calling RepositoriesOstreeApi.sync"
      end
      # resource path
      local_var_path = '{ostree_ostree_repository_href}sync/'.sub('{' + 'ostree_ostree_repository_href' + '}', CGI.escape(ostree_ostree_repository_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(repository_sync_url) 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesOstreeApi#sync\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update an ostree repository
    # Trigger an asynchronous update task
    # @param ostree_ostree_repository_href [String] 
    # @param ostree_ostree_repository [OstreeOstreeRepository] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def update(ostree_ostree_repository_href, ostree_ostree_repository, opts = {})
      data, _status_code, _headers = update_with_http_info(ostree_ostree_repository_href, ostree_ostree_repository, opts)
      data
    end

    # Update an ostree repository
    # Trigger an asynchronous update task
    # @param ostree_ostree_repository_href [String] 
    # @param ostree_ostree_repository [OstreeOstreeRepository] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def update_with_http_info(ostree_ostree_repository_href, ostree_ostree_repository, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesOstreeApi.update ...'
      end
      # verify the required parameter 'ostree_ostree_repository_href' is set
      if @api_client.config.client_side_validation && ostree_ostree_repository_href.nil?
        fail ArgumentError, "Missing the required parameter 'ostree_ostree_repository_href' when calling RepositoriesOstreeApi.update"
      end
      # verify the required parameter 'ostree_ostree_repository' is set
      if @api_client.config.client_side_validation && ostree_ostree_repository.nil?
        fail ArgumentError, "Missing the required parameter 'ostree_ostree_repository' when calling RepositoriesOstreeApi.update"
      end
      # resource path
      local_var_path = '{ostree_ostree_repository_href}'.sub('{' + 'ostree_ostree_repository_href' + '}', CGI.escape(ostree_ostree_repository_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(ostree_ostree_repository) 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PUT, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesOstreeApi#update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
